/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _SIGNAL_H
#define _SIGNAL_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) signal.h 9.8 92/06/19 ")
#else
#ident "@(#) signal.h 9.8 92/06/19 "
#endif 

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#ifndef _SIG_ATOMIC_T
#define _SIG_ATOMIC_T
   /* atomic entity for signal handling */
   typedef int sig_atomic_t;
#endif

#if	defined(_XOPEN_SOURCE) && defined(_XOPEN_XPG4)
#ifndef	_PID_T
#define	_PID_T
typedef short pid_t;
#endif
#endif

#ifndef	_SYS_SIGNAL_H
#include <sys/signal.h>
#endif

#ifdef	_SYS_SIGNAL_H
#undef         sigbit
#undef         sigemptyset
#undef         sigfillset
#undef         sigaddset
#undef         sigdelset
#undef         sigismember
#endif

#if defined(_NO_PROTOTYPE)
#if defined(_M_XOUT)
extern int (*signal())();
#else
extern void (*signal())();
#endif
#if !_STRICT_NAMES || (__STDC__ && !defined(_POSIX_SOURCE))
extern int raise();
#endif 
#if !defined (__STRICT_ANSI__)
extern  void (*sigset())();
extern  int (*ssignal())();
#endif 
#else /* !_NO_PROTOTYPE */

#if __cplusplus
extern "C" {
#endif 

#if defined(_M_XOUT)
extern int (*signal(int, int(*)(int)))(int);
#else
extern void (*signal(int, void(*)(int)))(int);
#endif 
#if !_STRICT_NAMES || (__STDC__ && !defined(_POSIX_SOURCE) )
extern int raise(int);
#endif
#if !defined (__STRICT_ANSI__)
extern  void ( *sigset( int, void(*)(int) ) )(int);
extern  int ( *ssignal( int, int(*)(int) ) )(int);
#endif 

#if __cplusplus
};
#endif 

#endif /* _NO_PROTOTYPE */

#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
#if defined(_NO_PROTOTYPE)
extern int sigfillset();
extern int sigemptyset();
extern int sigaddset();
extern int sigdelset();
extern int sigismember();
extern int sigpending();
extern int sigsuspend();
extern int sigprocmask();
extern int kill();
extern int sigaction();
#else /* !_NO_PROTOTYPE */

#if __cplusplus
#if	defined(_XOPEN_XPG4)
/*
 * This include is necessary to ensure that the right type for kill is
 * obtained regardless of the OS that the DS is being run on.
 */
#include <sys/types.h>
#endif

extern "C" {
#endif 

extern int sigfillset(sigset_t *);
#ifdef sigemptyset
#undef sigemptyset	/* Will be defined by sys/signal.h */
#endif
extern int sigemptyset(sigset_t *);
extern int sigaddset(sigset_t *, int);
extern int sigdelset(sigset_t *, int);
extern int sigismember(sigset_t *, int);
extern int sigpending(sigset_t *);
extern int sigsuspend(sigset_t *);
extern int sigprocmask(int, sigset_t *, sigset_t *);
#ifdef _SYS_TYPES_H
extern int kill(pid_t, int);
#else
extern int kill(short, int);
#endif 
extern int sigaction(int, struct sigaction *, struct sigaction *);

#if __cplusplus
};
#endif 

#endif /* _NO_PROTOTYPE */

#if !defined(__cplusplus)
# if !defined (__STRICT_ANSI__)
#  define raise(sig)  kill(getpid(), sig)
# endif
#endif /*__cplusplus*/

#endif /* _XOPEN_SOURCE || _POSIX_SOURCE || !defined (__STRICT_ANSI__) */

#define         __sigbit(n)       (1L << ((n) - 1))
#if !defined (__STRICT_ANSI__)
#ifndef sigbit
#define         sigbit(n)       (1L << ((n) - 1))
#endif 
#endif 

#ifndef __SIGALL
#define         __SIGALL	SIGALL
#endif

#if defined(_USE_MACROS) || !defined(_STRICT_NAMES)
/*
 *	The following do not correctly handle error conditions but
 * are faster and backwards compatible
 */
#define         sigemptyset(s)  (*(s) = ~__SIGALL)
#define         sigfillset(s)   (*(s) = __SIGALL)
#define         sigaddset(s,n)  (*(s) |= __sigbit(n))
#define         sigdelset(s,n)  (*(s) &= ~__sigbit(n))
#define		sigismember(set,n) (!((*(set) & __sigbit(n)) == 0))
#endif 

#endif /* _SIGNAL_H */


