
#ifdef __STDC__
#pragma comment(exestr, "@(#) unistd.h 10.3 92/09/17 ")
#else
#ident "@(#) unistd.h 10.3 92/09/17 "
#endif /* __STDC__ */
/*
 *	Copyright (C) The Santa Cruz Operation, 1992.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */
/*
 *   Copyright (C) The Santa Cruz Operation, Inc, 1988-1991
 *    All Rights Reserved
 *     The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *     The information in this file is provided "AS IS" without warranty.
 */

#ifndef _UNISTD_H
#define _UNISTD_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) unistd.h 10.9 92/07/07 ")
#else
#ident "@(#) unistd.h 10.9 92/07/07 "
#endif

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#if	defined(_XOPEN_SOURCE) && defined(_XOPEN_XPG4)
#ifndef	_SIZE_T
#define	_SIZE_T
typedef   unsigned int   size_t;
#endif
#ifndef	_SSIZE_T
#define	_SSIZE_T
typedef   int   ssize_t;
#endif
#ifndef	_UID_T
#define	_UID_T
typedef unsigned short   uid_t;
#endif
#ifndef	_GID_T
#define	_GID_T
typedef unsigned short   gid_t;
#endif
#ifndef	_OFF_T
#define	_OFF_T
typedef   long      off_t;
#endif
#ifndef	_PID_T
#define	_PID_T
typedef short  pid_t;
#endif
#endif

#ifndef	_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifndef	_SYS_UNISTD_H
#include <sys/unistd.h>
#endif

#ifndef NULL
#if defined(_KR) || defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void *)0)
#endif
#endif

#if defined(_NO_PROTOTYPE)
extern int        chown();
extern int        chroot();
extern size_t     confstr();
extern char *     crypt();
#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
extern int        eaccess();
extern int	   readlink();
extern int	   symlink();
#endif
extern void       encrypt();
extern pid_t      fork();
extern int        fsync();
extern gid_t      getegid();
extern uid_t      geteuid();
extern gid_t      getgid();
extern int        getgroups();
extern int        getopt();
extern char *     getpass();
extern pid_t      getpgrp();
extern pid_t      getpid();
extern pid_t      getppid();
extern uid_t      getuid();
#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
extern int        ioctl();
#endif
extern off_t      lseek();
extern int        nice();
extern int        setgid();
extern int        setpgid();
extern pid_t      setsid();
extern int        setuid();
extern void       swab();
extern pid_t      tcgetpgrp();
extern int        tcsetpgrp();
extern char *     getcwd();
extern char *     getlogin();
extern char *     ttyname();
extern void       _exit();
extern int        access();
extern unsigned int alarm();
extern int          chdir();
extern int          close();
extern char*        ctermid();
extern char*        cuserid();
extern int          dup();
extern int          dup2();
extern int          execl();
extern int          execle();
extern int          execlp();
extern int          execv();
extern int          execve();
extern int          execvp();
extern long         fpathconf();
extern int          isatty();
extern int          link();
extern long         pathconf();
extern int          pause();
extern int          pipe();
extern int          read();
extern int          rename();
extern int          rmdir();
extern unsigned int sleep();
extern long         sysconf();
extern int          unlink();
extern int          write();
#else /* !_NO_PROTOTYPE */

#if __cplusplus
extern "C" {
extern int utime(const char *, const struct utimbuf *); /* Also SVID */
#endif 

extern int        chown(const char *, uid_t, gid_t);
extern int        chroot( const char * );
extern size_t     confstr( const char * );
extern char *     crypt( const char *, const char * );
#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
extern int        eaccess(char *, int );
extern int	   readlink( const char *, void *, size_t );
extern int	   symlink( const char *, const char * );
#endif
extern void       encrypt( char [64], int );
extern pid_t      fork(void);
extern int        fsync( int );
extern gid_t      getegid(void);
extern uid_t      geteuid(void);
extern gid_t      getgid(void);
extern int        getgroups(int, gid_t *);
#ifdef _XOPEN_XPG4
/* Note, this is probably an oversight in the standard since it REALLY is a
   pointer to const characters */
extern int        getopt( int, char * const [], const char * );
#else
extern int        getopt( int, const char * const *, const char * );
#endif /* _XOPEN_XPG4 */
extern char *     getpass( const char * );
extern pid_t      getpgrp(void);
extern pid_t      getpid(void);
extern pid_t      getppid(void);
extern uid_t      getuid(void);
#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
extern int        ioctl(int, int, ... );
#endif
extern off_t      lseek(int, off_t, int);
extern int        nice( int );
extern int        setgid(gid_t);
extern int        setpgid(pid_t, pid_t);
extern pid_t      setsid(void);
extern int        setuid(uid_t);
#ifdef _XOPEN_XPG4
extern void       swab( const void *, void *, size_t );
#else
extern void       swab( const char *, char *, int );
#endif	/* _XOPEN_XPG4 */
extern pid_t      tcgetpgrp(int);
extern int        tcsetpgrp(int, pid_t);
extern char*        getcwd(char *, int);
extern char*        getlogin(void);
extern char*        ttyname(int);
extern void         _exit(int);
extern int          access(const char *, int);
extern unsigned int alarm(unsigned int);
extern int          chdir(const char *);
extern int          close(int);
extern char*        ctermid(char *);
extern char*        cuserid(char *);
extern int          dup(int);
extern int          dup2(int, int);
extern int          execl(const char *, const char *, ...);
extern int          execle(const char *, const char *, ...);
extern int          execlp(const char *, const char *, ...);
extern int          execv(const char *, const char *[]);
extern int          execve(const char *, const char * [], const char * []);
extern int          execvp(const char *, const char * []);
extern long         fpathconf(int, int);
extern int          isatty(int);
extern int          link(const char *, const char *);
extern long         pathconf(const char *, int);
extern int          pause(void);
extern int          pipe(int *);
extern int          read(int, void *, unsigned int);
extern int          rename(const char *, const char *);
extern int          rmdir(const char *);
extern unsigned int sleep(unsigned int);
extern long         sysconf(int);
extern int          unlink(const char *);
extern int          write(int, const void *, unsigned int);

#if __cplusplus
};
#endif

#endif /* _NO_PROTOTYPE */

#endif /* _UNISTD_H */
