/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _CTYPE_H
#define _CTYPE_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) ctype.h 10.2 92/03/26 ")
#else
#ident "@(#) ctype.h 10.2 92/03/26 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#define _U 01                   /* Uppercase */
#define _L 02                   /* Lowercase */
#define _N 04                   /* Numerical */
#define _S 010                  /* Space */
#define _P 020                  /* Punctuation */
#define _C 040                  /* Control Character */
#define _B 0100                 /* Blank */
#define _X 0200                 /* Hex digit */

#if _NO_PROTOTYPE

extern int isalpha();
extern int isalnum();
extern int iscntrl();
extern int isdigit();
extern int isgraph();
extern int islower();
extern int isprint();
extern int ispunct();
extern int isspace();
extern int isupper();
extern int isxdigit();
extern int toupper();
extern int tolower();

#if !defined (__STRICT_ANSI__) || defined(_XOPEN_SOURCE)
extern int isascii();
extern int toascii();
#endif
#else
#if __cplusplus
extern "C" {
#endif /* __cplusplus */
extern int isalpha(int);
extern int isalnum(int);
extern int iscntrl(int);
extern int isdigit(int);
extern int isgraph(int);
extern int islower(int);
extern int isprint(int);
extern int ispunct(int);
extern int isspace(int);
extern int isupper(int);
extern int isxdigit(int);
extern int toupper(int);
extern int tolower(int);

#if !defined (__STRICT_ANSI__) || defined(_XOPEN_SOURCE)
extern int isascii(int);
extern int toascii(int);
#endif
#if __cplusplus
};
#endif /* __cplusplus */
#endif /* _NO_PROTOTYPE */

#if !_STRICT_NAMES
#define __ctype _ctype
#ifdef _M_INTERNAT
#define __cuclc _cuclc
#endif /* _M_INTERNAT */
#endif /* !_STRICT_NAMES */

extern unsigned char __ctype[];

#ifdef _M_INTERNAT
extern unsigned char __cuclc[];
#define __toupper(c) ((__cuclc+1)[((unsigned char) (c))])
#define __tolower(c) ((__cuclc+1)[((unsigned char) (c))])
#else
#define __toupper(c) (((unsigned char)(c))-'a'+'A')
#define __tolower(c) (((unsigned char)(c))-'A'+'a')
#endif /* _M_INTERNAT */

#define isalpha(c)     ((__ctype+1)[((unsigned char) (c))]&(_U|_L))
#define isupper(c)     ((__ctype+1)[((unsigned char) (c))]&_U)
#define islower(c)     ((__ctype+1)[((unsigned char) (c))]&_L)
#define isdigit(c)     ((__ctype+1)[((unsigned char) (c))]&_N)
#define isxdigit(c)    ((__ctype+1)[((unsigned char) (c))]&_X)
#define isspace(c)     ((__ctype+1)[((unsigned char) (c))]&_S)
#define ispunct(c)     ((__ctype+1)[((unsigned char) (c))]&(_P))
#define isalnum(c)     ((__ctype+1)[((unsigned char) (c))]&(_U|_L|_N))
#define isprint(c)     ((__ctype+1)[((unsigned char) (c))]&(_P|_U|_L|_N|_B))
#define isgraph(c)     ((__ctype+1)[((unsigned char) (c))]&(_P|_U|_L|_N))
#define iscntrl(c)     ((__ctype+1)[((unsigned char) (c))]&_C)

#if defined(_XOPEN_SOURCE) || !defined (__STRICT_ANSI__)
#define isascii(c)   ((unsigned)(c)<=0177)
#define toascii(c)   ((c)&0177)
#define _toupper(c)  __toupper(c)
#define _tolower(c)  __tolower(c)
#endif /* _XOPEN_SOURCE || !defined (__STRICT_ANSI__) */

#define __todigit(n)   ((char)((n)+'0'))
#define __toint(c)     ((int)((c)-'0'))
#if !defined (__STRICT_ANSI__)
#define todigit(n)   ((char)((n)+'0'))
#define toint(c)     ((int)((c)-'0'))
#endif /* !defined (__STRICT_ANSI__) */

#ifdef _USE_MACROS	/* Unsafe macros */
#define toupper(c)   (islower(c) ? __toupper(c) : (c))
#define tolower(c)   (isupper(c) ? __tolower(c) : (c))
#endif /* _USE_MACROS */

#endif /* _CTYPE_H */
