/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _DIRENT_H
#ifdef __cplusplus
extern "C" {
#endif
#define _DIRENT_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) dirent.h 10.4 92/06/02 ")
#else
#ident "@(#) dirent.h 10.4 92/06/02 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#ifdef	_M_I386
#pragma	pack(4)
#else
#pragma	pack(2)
#endif

#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE)
#define MAXNAMLEN 512     /* maximum filename length */
#define DIRBUF  1048      /* buffer size for fs-indep. dirs */
#endif /* !_XOPEN_SOURCE && !_POSIX_SOURCE */

#ifndef	_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifndef	_SYS_DIRENT_H
#include <sys/dirent.h>
#endif

#ifndef	_DIR
#define	_DIR
#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE)
typedef struct {
           int dd_fd;     /* file descriptor */
           int dd_loc;    /* offset in block */
           int dd_size;   /* amount of valid data */
           char *dd_buf;  /* directory block */
        } DIR;            /* stream data from opendir() */
	
#else
typedef struct {
           int __dd_fd;     /* file descriptor */
           int __dd_loc;    /* offset in block */
           int __dd_size;   /* amount of valid data */
           char *__dd_buf;  /* directory block */
        } DIR;            /* stream data from opendir() */
#endif /* !_XOPEN_SOURCE && !_POSIX_SOURCE */
#endif

#if defined(_NO_PROTOTYPE)
extern DIR            *opendir();
extern struct dirent  *readdir();
extern int            closedir();
#if !defined(_POSIX_SOURCE)
extern long           telldir();
extern void           seekdir();
#endif /* !_POSIX_SOURCE */
#else /* _NO_PROTOTYPE */

#if __cplusplus
extern "C" {
#endif /* __cplusplus */

extern DIR            *opendir(const char *);
extern struct dirent  *readdir(DIR *);
extern int            closedir(DIR *);
#if !defined(_POSIX_SOURCE)
extern long           telldir(DIR *);
extern void           seekdir(DIR *, long);

#endif /* !_POSIX_SOURCE */

#if __cplusplus
};
#endif /* __cplusplus */

#endif /* _NO_PROTOTYPE */

#if !defined(_POSIX_SOURCE)
#define rewinddir( dirp ) seekdir( dirp, 0L )
#endif

#pragma	pack()

#ifdef __cplusplus
#ifndef rewinddir
extern void rewinddir (DIR *);
#endif
#endif /* defined(__cplusplus) */
#ifdef __cplusplus
}
#endif
#endif /* _DIRENT_H*/
