/*
 * Copyright (C) 1987, 1988-1991 The Santa Cruz Operation, Inc.
*		All Rights Reserved.
 *     The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *     The information in this file is provided "AS IS" without warranty.
 * This Module contains Proprietary Information of
 * The Santa Cruz Operation.
 */

/* Category identifiers for setlocale(S) */

#ifndef _LOCALE_H
#define _LOCALE_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) locale.h 10.4 92/04/21 ")
#else
#ident "@(#) locale.h 10.4 92/04/21 "
#endif /* __STDC __ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#ifdef	_M_I386
#pragma	pack(4)
#else
#pragma	pack(2)
#endif

#ifndef NULL
#if defined(_KR) || defined(__cplusplus)
#define NULL	0
#else
#define NULL ((void *)0)
#endif 
#endif

#define LC_ALL  1           /* All the following */
#define LC_CTYPE 2          /* ctype(S), conv(S) */
#define LC_NUMERIC 3        /* printf(S), etc. */
#define LC_TIME  4          /* strftime(S) */
#define LC_COLLATE 5        /* strxfrm(S), strcoll(S) */

#if !defined (__STRICT_ANSI__)
#define LC_MESSAGES 6       /* Not yet used */
#endif /* !defined (__STRICT_ANSI__) */

#define LC_MONETARY 7       /* Not yet used */

#ifndef	_STRUCT_LCONV
#define	_STRUCT_LCONV
struct lconv {
   char *decimal_point;     /* "." */
   char *thousands_sep;     /* "" */
   char *grouping;          /* "" */
   char *int_curr_symbol;   /* "" */
   char *currency_symbol;   /* "" */
   char *mon_decimal_point; /* "" */
   char *mon_thousands_sep; /* "" */
   char *mon_grouping;      /* "" */
   char *positive_sign;     /* "" */
   char *negative_sign;     /* "" */
   char int_frac_digits;    /* CHAR_MAX */
   char frac_digits;        /* CHAR_MAX */
   char p_cs_precedes;      /* CHAR_MAX */
   char p_sep_by_space;     /* CHAR_MAX */
   char n_cs_precedes;      /* CHAR_MAX */
   char n_sep_by_space;     /* CHAR_MAX */
   char p_sign_posn;        /* CHAR_MAX */
   char n_sign_posn;        /* CHAR_MAX */
};
#endif

#if defined(_NO_PROTOTYPE)
extern char *setlocale();
extern struct lconv *localeconv();
#else

#if __cplusplus
extern "C" {
#endif /* __cplusplus */

extern char *setlocale(int, const char *); 
extern struct lconv *localeconv(void);

#if __cplusplus
};
#endif /* __cplusplus */

#endif /* _NO_PROTOTYPE */

#pragma	pack()

#endif /* _LOCALE_H */
