/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _SETJMP_H
#ifdef __cplusplus
extern "C" {
#endif
#define _SETJMP_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) setjmp.h 10.3 92/07/24 ")
#else
#ident "@(#) setjmp.h 10.3 92/07/24 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#if !defined (__STRICT_ANSI__)
#ifndef	_SYS_SIGNAL_H
#include <sys/signal.h>
#endif
#endif /* !defined (__STRICT_ANSI__) */

/*
 * Select the size of the save buffer depending on the processor type
 * and the memory model.
 */

#if defined(__i386) || defined(_M_I386)
#define _JBLEN 6
#ifdef _IBCS2
#define _SIGJBLEN 8
#endif /* _IBCS2 */
#elif defined(_M_I8086) || defined(_M_I186) || defined(_M_I286)
#if defined(_M_I86SM)
#define _JBLEN 5  /* shortret, sp, bp, si, di */
#elif defined(_M_I86MM) || defined(_M_I86CM) || defined(_M_I86HM) || \
	defined(_M_I86LM)
#define  _JBLEN 7  /* ret, sp, bp, si, di, (ds) */
#endif /* Various memory models */
#else
#ifdef _KR
error "_JBLEN should be defined, no machine type specified"
#else
#error "_JBLEN should be defined, no machine type specified"
#endif /* _KR */
#endif /* Machine type */

#ifndef	_JMP_BUF
#define	_JMP_BUF
typedef int jmp_buf[_JBLEN];
#endif

#if defined(_NO_PROTOTYPE)
extern int setjmp();
extern void longjmp();
#else

#if __cplusplus
extern "C" {
#endif /* __cplusplus */

extern int setjmp(jmp_buf);
extern void longjmp(jmp_buf, int);

#if __cplusplus
};
#endif /* __cplusplus */

#endif /* _NO_PROTOTYPE */

#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
/* The long should be sigset_t, check to ensure is still long */

#ifndef	_SIGJMP_BUF
#define	_SIGJMP_BUF
#ifdef _IBCS2
typedef int sigjmp_buf[_SIGJBLEN];
#else
typedef int sigjmp_buf[_JBLEN + 1 +
	(sizeof(long) + sizeof(int) - 1) / sizeof(int)];
#endif /* _IBCS2 */
#endif

#if __cplusplus
extern "C" {
#endif /* __cplusplus */
#if defined(_NO_PROTOTYPE)
extern int sigsetjmp();
extern void siglongjmp();
#else
extern int sigsetjmp(sigjmp_buf, int);
extern void siglongjmp(sigjmp_buf, int);
#endif /* _NO_PROTOTYPE */
#if __cplusplus
};
#endif /* __cplusplus */
#endif /* _XOPEN_SOURCE || _POSIX_SOURCE || !defined (__STRICT_ANSI__) */
  
#ifdef __cplusplus
}
#endif
#endif /* _SETJMP_H */
