/*
 *   Portions Copyright (C) 1984-1991 The Santa Cruz Operation, Inc.
 *            All Rights Reserved.
 *     The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *     The information in this file is provided "AS IS" without warranty.
 *   This Module contains Proprietary Information of
 *  The Santa Cruz Operation, and should be treated as Confidential.
 *
 *   stdio.h
 */

#ifndef _STDIO_H
#define _STDIO_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) stdio.h 10.4 92/08/19 ")
#else
#ident "@(#) stdio.h 10.4 92/08/19 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#ifdef    _M_I386
#pragma   pack(4)
#else
#pragma   pack(2)
#endif

#if !_STRICT_NAMES
#ifndef	_LIMITS_H
#include <limits.h>
#endif
#define   _POSIX_NAME_MAX   14   /* minimum value for NAME_MAX */
#endif 

#ifndef _FPOS_T
#define _FPOS_T
typedef long	fpos_t;
#endif 

#define   EOF               (-1)

#ifndef NULL
#if defined(_KR) || defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void *)0)
#endif /* defined(_KR) || defined(__cplusplus) */
#endif /* NULL */

#ifndef _SIZE_T
#define _SIZE_T
typedef   unsigned int      size_t;
#endif /* _SIZE_T */

#if !defined (__STRICT_ANSI__) || defined(_XOPEN_SOURCE)
#ifndef _VA_LIST
typedef   char         *va_list;
#define _VA_LIST
#endif
#endif

#ifndef TMP_MAX
#define   TMP_MAX           17576
#endif

#define   _IOFBF            0000
#define   _IONBF            0004
#define   _IOLBF            0100

/* Additional Non standards ones */

#define   _IOREAD           0001
#define   _IOWRT            0002
#define   _IOMYBUF          0010
#define   _IOEOF            0020
#define   _IOERR            0040
#define   _IORW             0200
#define   _SBFSIZ           8

#define   BUFSIZ            1024

#if !_STRICT_NAMES
#define _cnt __cnt
#define _ptr __ptr
#define _base __base
#define _file __file
#define _flag __flag

#define __iob _iob
#endif /* !_STRICT_NAMES */

#ifndef	_FILE
#define	_FILE
typedef struct {
#if __i386
	int            __cnt;
	unsigned char   *__ptr;
#else   /* for 286 OMF only */
	unsigned char   *__ptr;
	int            __cnt;
#endif
	unsigned char   *__base;
	char            __flag;
	char            __file;
} FILE;
#endif

#if _SHORT_FILENAMES 
#define   FILENAME_MAX   _POSIX_NAME_MAX
#else
#define   FILENAME_MAX   255
#endif

#if defined(_M_UNIX) && defined(_M_I386) && !defined(_IBCS2)
#define   FOPEN_MAX      128
#else
#define   FOPEN_MAX      60
#endif /* defined(_M_UNIX) && defined(_M_I386) && !defined(_IBCS2) */
#define   SEEK_SET        0
#define   SEEK_CUR        1
#define   SEEK_END        2


#if defined(_M_UNIX) && defined(_M_I386)
#ifdef	_IBCS2
#define   _NFILE        60
#else
#define   _NFILE        128
#endif /* _IBCS2 */
#else
#define   _NFILE        60
#endif /* defined(_M_UNIX) && defined(_M_I386) */


#define   stdin         (&__iob[0])
#define   stdout        (&__iob[1])
#define   stderr        (&__iob[2])
#define   L_tmpnam      (sizeof(_P_tmpdir) + 15)

#if !_STRICT_NAMES
#define __bufendtab     _bufendtab
#endif

#define   __bufend(p)   (__bufendtab[(p)->__file])
#define   __bufsiz(p)   (__bufend(p) - (p)->__base)

#if !_STRICT_NAMES
#define _bufend         __bufend
#define _bufsiz         __bufsiz
#endif

#define _P_tmpdir "/usr/tmp/" /* keep same as P_tmpdir below */

#ifdef	_XOPEN_SOURCE	/* To be withdrawn in XPG5	*/
extern char *	optarg;
extern int	opterr;
extern int	optind;
extern int	optopt;
#endif

#if __cplusplus
extern "C" {
#endif

#if defined(_NO_PROTOTYPE)
extern   int            remove();
extern   int            rename();
extern   FILE           *tmpfile();
extern   char           *tmpnam();
extern   int            fclose();
extern   int            fflush();
extern   FILE           *fopen();
extern   FILE           *freopen();
extern   void           setbuf();
extern   int            setvbuf();
extern   int            fprintf();
extern   int            fscanf(); 
extern   int            printf();
extern   int            scanf();
extern   int            sprintf();
extern   int            sscanf();
extern   int            vfprintf();
extern   int            vprintf();
extern   int            vsprintf();
extern   int            fgetc();
extern   char           *fgets();
extern   int            fputc();
extern   int            fputs();
extern   int            getc();
extern   int            getchar();
extern   char           *gets();
extern   int            putc();
extern   int            putchar();
extern   int            puts();
extern   int            ungetc();
#if  defined(_SVID)
extern   int          fread();
extern   int          fwrite();
#else
extern   size_t       fread();
extern   size_t       fwrite();
#endif
extern   int            fgetpos();
extern   int            fseek();
extern   int            fsetpos();
extern   long           ftell();
extern   void           rewind();
extern   void           clearerr();
extern   int            feof();
extern   int            ferror();
extern   void           perror();
#if !_STRICT_NAMES
extern   int            unlink();
extern   int            _filbuf();
extern   int            _flsbuf();
#else
extern   int            __unlink();
extern   int            __filbuf();
extern   int            __flsbuf();
#endif /* !_STRICT_NAMES */
#if !defined (__STRICT_ANSI__)
extern	 char           *ctermid();
extern	 char           *cuserid();
extern	 int            system();
#endif /* __STDC__ */
#if defined(_XOPEN_SOURCE) || !defined (__STRICT_ANSI__)
extern int         putw();
extern int         getw();
extern FILE        *popen();
extern int         pclose();
extern char        *tempnam();
#endif /* defined(_XOPEN_SOURCE) || !defined (__STRICT_ANSI__) */
#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
extern FILE        *fdopen();
extern int	    fileno();
#endif /* defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__) */

#else	/* !_NO_PROTOTYPE */
extern   int            remove(const char *);
extern   int            rename(const char *, const char *);
extern   FILE           *tmpfile(void);
extern   char           *tmpnam(char *);
extern   int            fclose(FILE *);
extern   int            fflush(FILE *);
extern   FILE           *fopen(const char *, const char *);
extern   FILE           *freopen(const char *, const char *, FILE *);
extern   void           setbuf(FILE *, char *);
extern   int            setvbuf(FILE *, char *, int, size_t);
extern   int            fprintf(FILE *, const char *, ...);
extern   int            fscanf(FILE *, const char *, ...); 
extern   int            printf(const char *, ...);
extern   int            scanf(const char *, ...);
extern   int            sprintf(char *, const char *, ...);
extern   int            sscanf(const char *, const char *, ...);
#ifdef _VA_LIST
extern   int            vfprintf(FILE *, const char *, va_list);
extern   int            vprintf(const char *, va_list);
extern   int            vsprintf(char *, const char *, va_list);
#else
extern   int            vfprintf(FILE *, const char *, char * /* va_list */);
extern   int            vprintf(const char *, char * /* va_list */);
extern   int            vsprintf(char *, const char *, char * /* va_list */);
#endif
extern   int            fgetc(FILE *);
extern   char           *fgets(char *, int, FILE *);
extern   int            fputc(int, FILE *);
extern   int            fputs(const char *, FILE *);
extern   int            getc(FILE *);
extern   int            getchar(void);
extern   char           *gets(char *);
extern   int            putc(int, FILE *);
extern   int            putchar(int);
extern   int            puts(const char *);
extern   int            ungetc(int, FILE *);
#if defined(_SVID)
extern   int            fread(void *, size_t, size_t, FILE *);
extern   int            fwrite(const void *, size_t, size_t, FILE *);
#else
extern   size_t         fread(void *, size_t, size_t, FILE *);
extern   size_t         fwrite(const void *, size_t, size_t, FILE *);
#endif
extern   int            fgetpos(FILE *, fpos_t *);
extern   int            fseek(FILE *, long int, int);
extern   int            fsetpos(FILE *, const fpos_t *);
extern   long           ftell(const FILE *);
extern   void           rewind(FILE *);
extern   void           clearerr(FILE *);
extern   int            feof(FILE *);
extern   int            ferror(FILE *);
extern   void           perror(const char *);
#if !_STRICT_NAMES
extern   int            unlink(const char *);
extern   int            _filbuf(FILE *);
extern   int            _flsbuf(unsigned char, FILE *);
#else
extern   int            __unlink(const char *);
extern   int            __filbuf(FILE *);
extern   int            __flsbuf(unsigned char, FILE *);
#endif /* !_STRICT_NAMES */
#if !defined (__STRICT_ANSI__)
extern   char           *ctermid(char *);
extern   char           *cuserid(char *);
extern   int            system(const char *);
#endif /* __STDC__ */

#if defined(_XOPEN_SOURCE) || !defined (__STRICT_ANSI__)
extern int         putw(int, FILE *);
extern int         getw(FILE *);
extern FILE        *popen(const char *, const char *);
extern int         pclose(FILE *);
extern char        *tempnam(const char *,const char *);
#endif /* defined(_XOPEN_SOURCE) || !defined (__STRICT_ANSI__) */

#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
extern FILE        *fdopen(int, const char *);
extern int	    fileno(FILE *);
#endif /* defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__) */

#endif /* _NO_PROTOTYPE */

extern   unsigned char  *__bufendtab[];
extern   FILE           __iob[_NFILE];

#if __cplusplus
};
#endif /* __cplusplus */

#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
#define L_ctermid     9
#define L_cuserid     9
#define fileno(p)   ((p)->__file)
#endif /* _XOPEN_SOURCE || _POSIX_SOURCE || !defined (__STRICT_ANSI__) */

#if defined(__cplusplus) && defined(_COMPAT322)
#include <stddef.h>
#endif /* __cplusplus && _COMPAT322 */

#include <errno.h>

#ifdef EBADF
#define _EBADF EBADF
#else
#define _EBADF 9  /* Only necessary for strict Ansi conformance */
#endif /* EBADF */

#if !defined (__STRICT_ANSI__) || __cplusplus
#define P_tmpdir      _P_tmpdir

#define getc(p)     ((p)->__flag & (_IORW | _IOREAD) ? \
                         (--(p)->__cnt < 0 ? _filbuf(p) : (int) *(p)->__ptr++):\
                         (errno = _EBADF, EOF))
#define putc(x, p)  (((p)->__flag & (_IORW | _IOWRT)) ? \
                         (--(p)->__cnt < 0 ? _flsbuf((unsigned char) (x), (p)):\
                         (int) (*(p)->__ptr++ = (unsigned char) (x))) : \
                         ((x), errno = _EBADF, EOF))
#else
#define getc(p)     ((p)->__flag & (_IORW | _IOREAD) ? \
                         (--(p)->__cnt < 0 ? __filbuf(p) : (int) *(p)->__ptr++):\
                         (errno = _EBADF, EOF))
#define putc(x, p)  (((p)->__flag & (_IORW | _IOWRT)) ? \
                         (--(p)->__cnt < 0 ? __flsbuf((unsigned char) (x), (p)):\
                         (int) (*(p)->__ptr++ = (unsigned char) (x))) : \
                         (errno = _EBADF, (x), EOF))
#endif /* !defined (__STRICT_ANSI__) */

#define getchar()       getc(stdin)
#define putchar(x)      putc((x), stdout)
#define clearerr(p)     ((void) ((p)->__flag &= ~(_IOERR | _IOEOF)))
#define feof(p)         ((p)->__flag & _IOEOF)
#define ferror(p)       ((p)->__flag & _IOERR)
#if !__cplusplus
#if __STDC__
#define remove(name)	(__unlink(name))
#else
#define remove(name)	(unlink(name))
#endif /* __STDC__ */
#endif /* __cplusplus */

#pragma	pack()

#endif /* _STDIO_H */
