/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _STRING_H
#define _STRING_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) string.h 10.5 92/05/07 ")
#else
#ident "@(#) string.h 10.5 92/05/07 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#if	defined(_XOPEN_XPG4)
#ifndef	_SIZE_T
#define	_SIZE_T
typedef	unsigned int size_t;
#endif

#ifndef	_STDDEF_H 
#include	<stddef.h>
#endif
#endif

#ifndef	_MEMORY_H
#include <memory.h>
#endif

#ifndef NULL
#if defined(_KR) || defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void *)0)
#endif /* defined(_KR) || defined(__cplusplus) */
#endif /* NULL */

#if defined(_NO_PROTOTYPE)

#if defined(_SVID)
extern int strlen();                     
extern int strspn();
extern int strcspn();
#else
extern size_t strlen();                     
extern size_t strspn();
extern size_t strcspn();
#endif /* _SVID */

extern char *strcpy(); 
extern char *strncpy();
extern char *strcat(); 
extern char *strncat();
extern int strcmp();
extern int strcoll();
extern int strncmp();
extern size_t strxfrm();
extern char *strchr();        
extern char *strpbrk();
extern char *strrchr();       
extern char *strstr();
extern char *strtok(); 
extern char *strerror();                              

#if !defined (__STRICT_ANSI__)
extern void perror();
extern char *strdup();
#endif 

#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE)
extern int strncoll();
#endif

#else /* !_NO_PROTOTYPE */

#if __cplusplus
extern "C" {
#endif

#if defined(_SVID)
extern int strlen(char *);                     
extern int strspn(char *, char *);
extern int strcspn(char *, char *);
#else
extern size_t strlen(const char *);                     
extern size_t strspn(const char *, const char *);
extern size_t strcspn(const char *, const char *);
#endif /* _SVID */

extern char *strcpy(char *, const char *); 
extern char *strncpy(char *, const char *, size_t);
extern char *strcat(char *, const char *); 
extern char *strncat(char *, const char *, size_t);
extern int strcmp(const char *, const char *);
extern int strcoll(const char *, const char *);
extern int strncmp(const char *, const char *, size_t);
extern size_t strxfrm(char *, const char *, size_t);
extern char *strchr(const char *, int);        
extern char *strpbrk(const char *, const char *);
extern char *strrchr(const char *, int);       
extern char *strstr(const char *, const char *);
extern char *strtok(char *, const char *); 
extern char *strerror(int);                              

#if !defined (__STRICT_ANSI__)
extern void perror(const char *);
extern char *strdup(const char *);
#endif 

#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE)
extern int strncoll(char *, char *, int );
#endif

#if __cplusplus
};
#endif

#endif /* _NO_PROTOTYPE */

#if !defined (__STRICT_ANSI__)
extern int sys_nerr;
extern char *sys_errlist[];
#endif /* !defined (__STRICT_ANSI__) */

extern int __sys_nerr;
extern char *__sys_errlist[];

#if defined(_M_XOUT)	
#define strerror(error) ((((error) < (sys_nerr)) && ((error) >= 0)) ? \
                              sys_errlist[(error)] : (char *)NULL)
#elif defined(_USE_MACROS) /* Unsafe macro */

#ifdef _STRICT_NAMES	/* Should change when libraries fixed */
#define strerror(error) ((((error) < (__sys_nerr)) && ((error) >= 0)) ? \
                              __sys_errlist[(error)] : (char *)NULL)
#else
#define strerror(error) ((((error) < (sys_nerr)) && ((error) >= 0)) ? \
                              sys_errlist[(error)] : (char *)NULL)
#endif /* _STRICT_NAMES */

#endif /* _USE_MACROS */

#endif /* _STRING_H */
