#ifndef _SYS_ERRNO_H
#define _SYS_ERRNO_H
#ifdef __STDC__
#pragma comment(exestr, "@(#) errno.h 25.2 92/09/09 ")
#else
#ident "@(#) errno.h 25.2 92/09/09 "
#endif
/*
 *	Copyright (C) 1988-1992 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */
/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* #ident	"@)#(head.sys:errno.h	1.3.1.1" */

#if !_STRICT_NAMES && defined(M_I286) && !defined(_M_I286)
#define _M_I286 M_I286
#endif /* Eliminate name space pollution */

#if !_STRICT_NAMES && defined(M_XOUT) && !defined(_M_XOUT)
#define _M_XOUT M_XOUT
#endif /* Eliminate name space pollution */

/*
 * Error codes
 */

#define	EPERM	1	/* Not owner				*/
#define	ENOENT	2	/* No such file or directory		*/
#define	ESRCH	3	/* No such process			*/
#define	EINTR	4	/* Interrupted system call		*/
#define	EIO	5	/* I/O error				*/
#define	ENXIO	6	/* No such device or address		*/
#define	E2BIG	7	/* Arg list too long			*/
#define	ENOEXEC	8	/* Exec format error			*/
#define	EBADF	9	/* Bad file number			*/
#define	ECHILD	10	/* No child processes			*/
#define	EAGAIN	11	/* No more processes			*/
#define	ENOMEM	12	/* Not enough space			*/
#define	EACCES	13	/* Permission denied			*/
#define	EFAULT	14	/* Bad address				*/
#if !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
#define	ENOTBLK	15	/* Block device required		*/
#endif /* !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE) */
#define	EBUSY	16	/* Device busy				*/
#define	EEXIST	17	/* File exists				*/
#define	EXDEV	18	/* Cross-device link			*/
#define	ENODEV	19	/* No such device			*/
#define	ENOTDIR	20	/* Not a directory			*/
#define	EISDIR	21	/* Is a directory			*/
#define	EINVAL	22	/* Invalid argument			*/
#define	ENFILE	23	/* File table overflow			*/
#define	EMFILE	24	/* Too many open files			*/
#define	ENOTTY	25	/* Not a typewriter			*/
#if !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
#define	ETXTBSY	26	/* Text file busy			*/
#endif /* !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE) */
#define	EFBIG	27	/* File too large			*/
#define	ENOSPC	28	/* No space left on device		*/
#define	ESPIPE	29	/* Illegal seek				*/
#define	EROFS	30	/* Read-only file system		*/
#define	EMLINK	31	/* Too many links			*/
#define	EPIPE	32	/* Broken pipe				*/

#define	EDOM	33	/* Argument out of domain		*/
#define	ERANGE	34	/* Result too large			*/

#define	ENOMSG	35	/* No message of desired type		*/
#define	EIDRM	36	/* Identifier removed			*/

#define	ECHRNG	37	/* Channel number out of range		*/
#define	EL2NSYNC 38	/* Level 2 not synchronized		*/
#define	EL3HLT	39	/* Level 3 halted			*/
#define	EL3RST	40	/* Level 3 reset			*/
#define	ELNRNG	41	/* Link number out of range		*/
#define	EUNATCH 42	/* Protocol driver not attached		*/
#define	ENOCSI	43	/* No CSI structure available		*/
#define	EL2HLT	44	/* Level 2 halted			*/

#define	EDEADLK	45	/* Deadlock situation detected/avoided	*/
#define	ENOLCK	46	/* No record locks available		*/

/* Convergent Error Returns */
#define EBADE	50	/* Bad exchange descriptor		*/
#define EBADR	51	/* Bad request descriptor		*/
#define EXFULL	52	/* Message tables full			*/
#define ENOANO	53	/* Anode table overflow			*/
#define EBADRQC	54	/* Bad request code			*/
#define EBADSLT	55	/* Invalid slot				*/
#define EDEADLOCK 56	/* File locking deadlock		*/

#define EBFONT	57	/* Bad font file format			*/

/* stream problems */
#define ENOSTR	60	/* Not a stream device			*/
#define ENODATA	61	/* No data available			*/
#define ETIME	62	/* Timer expired			*/
#define ENOSR	63	/* Out of stream resources		*/

#define ENONET	64	/* Machine is not on the network	*/
#define ENOPKG	65	/* Package not installed		*/
#define EREMOTE	66	/* Object is remote			*/
#define ENOLINK	67	/* Link has been severed		*/
#define EADV	68	/* Advertise error			*/
#define ESRMNT	69	/* Srmount error			*/

#define	ECOMM	70	/* Communication error on send		*/
#define EPROTO	71	/* Protocol error			*/
#define	EMULTIHOP 74	/* Multihop attempted			*/
#define ELBIN	75	/* Inode is remote (not really error)	*/
#define	EDOTDOT 76	/* Cross mount point (not really error)	*/
#define EBADMSG 77	/* Not a data message			*/

#define ENAMETOOLONG 78	/* Filename too long			*/

#define	EOVERFLOW 79	/* (Reserved for future use)		*/

#define ENOTUNIQ 80	/* Name not unique on network		*/
#define EBADFD	 81	/* File descriptor in bad state		*/
#define EREMCHG	 82	/* Remote address changed		*/

/* shared library problems */
#define ELIBACC	83	/* Can not access a needed shared library	*/
#define ELIBBAD	84	/* Accessing a corrupted shared library		*/
#define ELIBSCN	85	/* .lib section in a.out corrupted		*/
#define ELIBMAX	86	/* Attempting to link in too many shared libs.	*/
#define ELIBEXEC 87	/* Can not exec a shared library directly	*/

#define	EILSEQ	88	/* Illegal byte sequence */

#define ENOSYS	89	/* Function not implemented			*/

#if !defined (__STRICT_ANSI__)
/*
 *	System V STREAMS TCP
 */
/* Errors from 4.2 BSD picked up to support sockets */
/* Note that the numbers are different from 4.2 numbering */

#define TCPERR		90
/* non-blocking and interrupt i/o */
#define EWOULDBLOCK     (TCPERR+0)       /* Operation would block */
#define EINPROGRESS     (TCPERR+1)       /* Operation now in progress */
#define EALREADY        (TCPERR+2)       /* Operation already in progress */
/* ipc/network software */

/* argument errors */
#define ENOTSOCK        (TCPERR+3)       /* Socket operation on non-socket */
#define EDESTADDRREQ    (TCPERR+4)       /* Destination address required */
#define EMSGSIZE        (TCPERR+5)       /* Message too long */
#define EPROTOTYPE      (TCPERR+6)       /* Protocol wrong type for socket */
#define EPROTONOSUPPORT (TCPERR+7)       /* Protocol not supported */
#define ESOCKTNOSUPPORT (TCPERR+8)       /* Socket type not supported */
#define EOPNOTSUPP      (TCPERR+9)       /* Operation not supported on socket */
#define EPFNOSUPPORT    (TCPERR+10)      /* Protocol family not supported */
#define EAFNOSUPPORT    (TCPERR+11)      /* Address family not supported by protocol family */
#define EADDRINUSE      (TCPERR+12)      /* Address already in use */
#define EADDRNOTAVAIL   (TCPERR+13)      /* Can't assign requested address */

/* operational errors */
#define ENETDOWN        (TCPERR+14)      /* Network is down */
#define ENETUNREACH     (TCPERR+15)      /* Network is unreachable */
#define ENETRESET       (TCPERR+16)      /* Network dropped connection on reset */
#define ECONNABORTED    (TCPERR+17)      /* Software caused connection abort */
#define ECONNRESET      (TCPERR+18)      /* Connection reset by peer */
#define ENOBUFS         ENOSR            /* Out of stream resources */
#define EISCONN         (TCPERR+20)      /* Socket is already connected */
#define ENOTCONN        (TCPERR+21)      /* Socket is not connected */
#define ESHUTDOWN       (TCPERR+22)      /* Can't send after socket shutdown */
#define ETOOMANYREFS    (TCPERR+23)      /* Too many references: can't splice */
#define ETIMEDOUT       (TCPERR+24)      /* Connection timed out */
#define ECONNREFUSED    (TCPERR+25)      /* Connection refused */


/* should be rearranged */
#define EHOSTDOWN       (TCPERR+26)      /* Host is down */
#define EHOSTUNREACH    (TCPERR+27)      /* No route to host */
#define ENOPROTOOPT     (TCPERR+28)      /* Protocol not available */

/* XENIX error numbers */
#define EUCLEAN	135	/* Structure needs cleaning		*/
#define ENOTNAM	137	/* Not a name file			*/
#define ENAVAIL	138	/* Not available			*/
#define EISNAM	139	/* Is a name file			*/
#define EREMOTEIO 140	/* Remote I/O error			*/
#define EINIT	141	/* (Reserved for future use)		*/
#define EREMDEV	142	/* Error 142				*/
#endif /* !defined (__STRICT_ANSI__) */

#define ENOTEMPTY 145	/* Directory not empty			*/

#if !defined (__STRICT_ANSI__)
#define	ELOOP	150	/* Too many symbolic links in path	*/

#define	ESTALE	151	/* (Reserved for future use)		*/
#define	EIORESID 500	/* (Reserved for future use)		*/

#if defined(_M_I286) && defined(_M_XOUT)
#	undef	EUCLEAN
#	define	EUCLEAN	35
#	undef	EDEADLOCK
#	define	EDEADLOCK	36
#	undef	EDEADLK
#	define	EDEADLK	EDEADLOCK
#	undef	ENOTNAM
#	define	ENOTNAM	37
#	undef	ENAVAIL
#	define	ENAVAIL	38
#	undef	EISNAM
#	define	EISNAM	39
#	undef	EREMOTEIO
#	define	EREMOTEIO	40
#	undef	EINIT
#	define	EINIT	41
#	undef	EREMDEV
#	define	EREMDEV	42
#	undef	ENOMSG
#	define	ENOMSG	43
#	undef	EIDRM
#	define	EIDRM	44
#	undef	ENOLCK
#	define	ENOLCK	45
#endif	/* defined(_M_I286) && defined(_M_XOUT) */
#endif /* !defined (__STRICT_ANSI__) */

#endif	/* _SYS_ERRNO_H */
