/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1990 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright (C) 1983-1991 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 *      The information in this file is provided for the exclusive use of
 *      the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *      right to use, modify, and incorporate this code into other products
 *      for purposes authorized by the license agreement provided they include
 *      this notice and the associated copyright notice with any such product.
 *      The information in this file is provided "AS IS" without warranty.
 *
 *		Copyright (c) 1984, 1986, 1987, 1988 AT&T
 *			  All Rights Reserved
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 */

#ifndef _TIME_H
#define _TIME_H

#ifdef __STDC__
#pragma comment(exestr, "@(#) time.h 10.4 92/04/21 ")
#else
#ident "@(#) time.h 10.4 92/04/21 "
#endif /* __STDC__ */

#if  !_STRICT_NAMES && !defined(_STRICTNAME_H)
#include  <strictname.h>
#endif

#ifdef    _M_I386
#pragma   pack(4)
#else
#pragma   pack(2)
#endif

#ifndef NULL
#if defined(_KR) || defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void *)0)
#endif 
#endif 

/* Probably bug in the xopen standard */
#ifndef _CLOCK_T
#define _CLOCK_T
typedef long clock_t;
#endif

#ifndef _TIME_T
#define _TIME_T
typedef long  time_t;
#endif

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int size_t;
#endif

#ifndef	_STRUCT_TM
#define	_STRUCT_TM
struct tm {                     /* see ctime(S) */
 int tm_sec;                    /* time of day, seconds */
 int tm_min;                    /* time of day, minutes */
 int tm_hour;                   /* time of day, hours (24 hour clock) */
 int tm_mday;                   /* day of month (1-31) */
 int tm_mon;                    /* month of year (0-11) */
 int tm_year;                   /* year - 1900 */
 int tm_wday;                   /* day of week (Sunday = 0) */
 int tm_yday;                   /* day of year (0-365) */
 int tm_isdst;                  /* non-0 if summer time in effect */
#if __STDC__
 long __tm_tzadj;                 /* seconds from GMT (east < 0) */
#define __LTZNMAX 50
   char __tm_name[__LTZNMAX];       /* name of timezone */
#else
 long tm_tzadj;                 /* seconds from GMT (east < 0) */
#define LTZNMAX 50
   char tm_name[LTZNMAX];      /* name of timezone */
#endif /* __STDC __*/
};
#endif


#if defined(_NO_PROTOTYPE)
extern clock_t clock();
extern double difftime();
extern time_t mktime();
extern time_t time();
extern char *asctime();
extern char  *ctime();
extern struct tm *gmtime();
extern struct tm *localtime();
extern size_t strftime();

#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
extern void ftime ();
extern char *	nl_cxtime();
extern char *	nl_ascxtime();
#endif

#else

#if __cplusplus
extern "C" {
#endif

extern clock_t clock(void);
extern double difftime(time_t, time_t);
extern time_t mktime(struct tm *);
extern time_t time(time_t *);
extern char *asctime(const struct tm *);
extern char  *ctime(const time_t *);
extern struct tm *gmtime(const time_t *);
extern struct tm *localtime(const time_t *);
extern size_t strftime(char *, size_t, const char *, const struct tm *);
extern char *	strptime(const char *, const char *, struct tm *);

#if !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) && !defined (__STRICT_ANSI__)
#ifndef _SYS_TIMEB_H
#include <sys/timeb.h>
#endif
extern void ftime ( struct timeb * );
extern char *	nl_cxtime( long *, char * );
extern char *	nl_ascxtime( struct tm *, char * );
#endif

#if __cplusplus
};
#endif

#endif	/* _NO_PROTOTYPE */

/* Strictly speaking this is defined only for Ansi C but 
 * we're going to pollute the name space anyway
 */
#define CLOCKS_PER_SEC 100

#if defined(_XOPEN_SOURCE) || defined(_POSIX_SOURCE) || !defined (__STRICT_ANSI__)
#define CLK_TCK 100
#if __cplusplus
extern "C" {
#endif /* __cplusplus */
#if defined(_NO_PROTOTYPE)
extern void tzset();
#else
extern void tzset(void);
#endif 

#ifndef _POSIX_SOURCE
extern long timezone;
extern int daylight;
#endif
#if !defined (__STRICT_ANSI__)
extern long altzone;
#endif
extern char *tzname[];
#if __cplusplus
};
#endif
#endif /* !defined (__STRICT_ANSI__) || _XOPEN_SOURCE || _POSIX_SOURCE */

#ifndef difftime
#define difftime(t1, t0) ((double)((t1) - (t0)))
#endif

#pragma	pack()

#endif /* _TIME_H */
