#ident	"@(#) curses.ed 10.1 92/04/21 "
/*
 *
 *
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1989 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright 1983-1989 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 */
/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* #ident	"@(#)libcurses:screen/copyright.h	1.2" */
#ident "@(#) copyright.h 1.3 88/12/14 "
/*
 * curses.h - this file is automatically made from caps and
 *	curses.ed. Don't make changes directly to curses.h!
 */
#ifndef _TINFO_H
#define _TINFO_H	/* define prevents multiple includes */

#ifdef	__STDC__
#pragma	comment(exestr, "@(#) curses.ed 10.1 92/04/21 ")
#else
#endif

#if !_STRICT_NAMES && defined(M_COFF) && !defined(_M_COFF)
#define _M_COFF M_COFF
#endif /* Eliminate Name Space Pollution */

#if !_STRICT_NAMES && defined(M_SYSV) && !defined(_M_SYSV)
#define _M_SYSV M_SYSV
#endif /* Eliminate Name Space Pollution */

#if !_STRICT_NAMES && defined(M_UNIX) && !defined(_M_UNIX)
#define _M_UNIX M_UNIX
#endif /* Eliminate Name Space Pollution */

#if !_STRICT_NAMES && defined(M_I286) && !defined(_M_I286)
#define _M_I286 M_I286
#endif /* Eliminate Name Space Pollution */

#ifdef    _M_I386
#pragma   pack(4)
#else
#pragma   pack(2)
#endif

#include  <stdio.h>

#ifdef _M_SYSV
#define SYSV
#endif

#ifdef SYSV
#ifndef _TERMIO_H
#include <termio.h>
#endif /* _TERMIO_H */
    typedef struct termio SGTTY;
#else /* !SYSV */
#ifndef _SGTTY_H
#include <sgtty.h>
#endif /* _SGTTY_H */
    typedef struct sgttyb SGTTY;
/*
 * Here we attempt to improve portability by providing some #defines
 * for SYSV functions on non-SYSV systems.
 */

#define memcpy(dst, src, len)	bcopy((src), (dst), (len))
#define strchr			index
#define strrchr		rindex
#endif /* SYSV */

typedef	unsigned char bool;

#define _VR3_COMPAT_CODE
/*
 * chtype is the type used to store a character together with attributes.
 * It can be set to "char" to save space, or "long" to get more attributes.
 */
#ifdef	CHTYPE
	typedef	CHTYPE chtype;
#else
	typedef unsigned long chtype;
#endif /* CHTYPE */

/*
	Define for the 'old' definition of chtype is required
	when we are running in compatibility mode
*/
#ifdef _VR3_COMPAT_CODE
typedef unsigned short _ochtype;
#endif

/* TRUE and FALSE get defined so many times, */
/* let's not get in the way of other definitions. */
#if !defined(TRUE) || ((TRUE) != 1)
#define	TRUE	(1)
#endif
#if !defined(FALSE) || ((FALSE) != 0)
#define	FALSE	(0)
#endif
#if !defined(ERR) || ((ERR) != -1)
#define	ERR	(-1)
#endif
#if !defined(OK) || ((OK) != 0)
#define	OK	(0)
#endif

/* short-hand notations */
typedef struct _win_st	WINDOW;
typedef struct screen	SCREEN;

struct _win_st
{
	short		_cury, _curx;	/* current coordinates */
	short		_maxy, _maxx;	/* max coordinates */
	short		_begy, _begx;	/* (0,0) screen coordinates */
	unsigned char	_flags;
	short		_yoffset;	/* actual begy is _begy+_yoffset */
	bool		_clear,	/* clearok() info */
			_leave,	/* leaveok() info */
			_immed,	/* window in immediate mode */
			_sync;		/* auto syncup of parent */
	WINDOW		*_padwin;	/* "pad" area for current window */
#ifdef	_VR3_COMPAT_CODE
	_ochtype	**_y16;	/* MUST stay at this offset in WINDOW */
#endif
	short		*_firstch;	/* first change in line */
	short		*_lastch;	/* last change in line */
	short		_tmarg, _bmarg;	/* scrolling region bounds */
				/* MUST stay at this offset in WINDOW */
	unsigned	_scroll		: 1;	/* scrollok() info */
	unsigned	_use_idl	: 1;	
	unsigned	_use_keypad	: 1;
	unsigned	_notimeout	: 1;
	unsigned	_use_idc	: 1;	
	chtype		_attrs;	/* current window attributes */
	chtype		_bkgd;		/* background, normally blank */
	int		_delay;		/* delay period on wgetch
					 * 0:  for nodelay
					 * <0: for infinite delay
					 * >0: delay time in units of millisec
					 */
	short		_ndescs;	/* number of descendants */
	short		_parx, _pary;	/* coords relative to parent (0,0) */
	WINDOW		*_parent;	/* the parent if this is a subwin */
	chtype		**_y;			/* lines of data */
};

/* _lastch is initially set to this, _firstch is set to win->_maxx */
#define	_NOCHANGE	-1
#define _INFINITY	16000	/* no line can be longer than this */

/* values for win->_flags */
#define	_ISPAD		001
#define	_WINCHANGED	002
#define	_WINMOVED	004
#define	_WINSDEL	010
#define	_CANT_BE_IMMED	020
#define	_WIN_ADD_ONE	040
#define	_WIN_INS_ONE	100

#define STUPID		0
#define UNKNOWN		1
#define CURS_BAD_MALLOC	2

/*
 * Various tricks to shut up __lint about things that are perfectly fine.
 */
#if defined(__lint) && !defined(CURSES) /* if not internal to curses source */
 struct screen {
	 int _nobody_;
 };
#endif /* __lint */

/* common external variables */

#ifdef __cplusplus
extern "C" int	LINES, COLS, TABSIZE, COLORS, COLOR_PAIRS;
extern "C" short	curs_errno;
extern "C" WINDOW	*stdscr, *curscr;
extern "C" unsigned char	ttytype[];
#else
extern	int	LINES, COLS, TABSIZE, COLORS, COLOR_PAIRS;

extern	short	curs_errno;

extern	WINDOW	*stdscr, *curscr;

extern	unsigned char	ttytype[];
#endif	/* __cplusplus */

/* Function declarations */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef _NO_PROTOTYPE
extern	SCREEN	*newscreen(char *, int, int, int, FILE *, FILE *),
		*setcurscreen(SCREEN *);

extern	WINDOW	*initscr(void),
		*newwin(int, int, int, int),
		*newpad(int, int),
		*derwin(WINDOW *, int, int, int, int),
		*dupwin(WINDOW *),
		*getwin(FILE *);

extern	chtype	winch(WINDOW *);

extern bool 	can_change_color(void),
		has_colors(void);

extern	int	baudrate(void),
		beep(void),
		color_content(short, short *, short *, short *),
		copywin(WINDOW *, WINDOW *, int, int, int, int, int, int, int),
		delwin(WINDOW *),
		delay_output(int),
		doupdate(void),
		echo(void), noecho(void),
		endwin(void), isendwin(void),
		filter(void),
		flash(void),
		halfdelay(int),
		has_ic(void),
		has_il(void),
		idlok(WINDOW *, char),
		init_color(short, short, short, short),
		init_pair(short, short, short),
		intrflush(WINDOW *, int), 
		keypad(WINDOW *, int),
		meta(WINDOW *, int), 
		mvcur(int, int, int, int),
		mvprintw(int, int, char *, ...),
		mvscanw(int, int, char *, ...),
		mvwaddch(WINDOW *, int, int),
		mvwdelch(WINDOW *, int, int),
		mvwin(WINDOW *, int, int),
		mvwprintw(WINDOW *, int, int, char *, ...),
		mvwscanw(WINDOW *, int, int, char *, ...),
		napms(int),
		nl(void), nonl(void),
		overlay(WINDOW *, WINDOW *),
		overwrite(WINDOW *, WINDOW *),
		pair_content(short, short *, short *),
		prefresh(WINDOW *, int, int, int, int, int, int),
		pnoutrefresh(WINDOW *, int, int, int, int, int, int),
		printw(char *, ...),
		scanw(char *, ...),
		scroll(WINDOW *),
		setupterm(char *, int, int *),
		start_color(void),
		touchwin(WINDOW *), touchline(WINDOW *, int, int),
		ttimeout(int),
		typeahead(int),
		vwprintw(WINDOW *, char *, ...),
		vwscanw(WINDOW *, char *, ...);

extern	int	waddstr(WINDOW *, char *),
		waddnstr(WINDOW *, char *, int),
		wclear(WINDOW *), wclrtobot(WINDOW *), wclrtoeol(WINDOW *),
		wdelch(WINDOW *),
		wdeleteln(WINDOW *),
		werase(WINDOW *),
		wgetch(WINDOW *), /* because it can return KEY_*, for example.*/
		wgetstr(WINDOW *, char *),
		winsdelln(WINDOW *, int),
		winsertln(WINDOW *),
		wmove(WINDOW *, int, int),
		wnoutrefresh(WINDOW *),
		wprintw(WINDOW *, char *, ...),
		wredrawln(WINDOW *, int, int),
		wrefresh(WINDOW *),
		wscanw(WINDOW *, char *, ...),
		wscrl(WINDOW *, int),
		wsetscrreg(WINDOW *, int, int);
#if __cplusplus
}
#endif /* __cplusplus */

#else
extern	SCREEN	*newscreen(/*termname,lines,cols,tabsiz,fout,fin*/),
		*setcurscreen(/*screenptr*/);

extern	WINDOW	*initscr(),
		*newwin(/*nlines,ncols,begy,begx*/),
		*newpad(/*nlines,ncols*/),
		*derwin(/*orig,nlines,ncols,begy,begx*/),
		*dupwin(/*orig*/),
		*getwin(/*file*/);

extern	chtype	winch();

extern	int	wgetch(); /* because it can return KEY_*, for instance. */
#endif /* _NO_PROTOTYPE */

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */
#ifdef _SVID
extern char
#else
extern unsigned char
#endif

#ifndef _NO_PROTOTYPE
	*longname(void),	/* long name of terminal */
	*termname(void),	/* effective terminal name */
	*keyname(int),		/* name of token returned by wgetch() */
	*slk_label(int),
	erasechar(void),
	killchar(void),
#else
	*longname(),	/* long name of terminal */
	*termname(),	/* effective terminal name */
	*keyname(),		/* name of token returned by wgetch() */
	*slk_label(),
	erasechar(),
	killchar(),
#endif /* _NO_PROTOTYPE */
	curs_parm_err[],
	*curs_err_strings[];
#if __cplusplus
}
#endif /* __cplusplus */

#ifndef _NO_PROTOTYPE
#ifdef __cplusplus
/* to get TERMINAL */
#include <term.h>
extern "C" {
#else
#ifndef _TERM_H
#define TERMINAL void	/* Dreadful kludge, but ... */
#endif
#endif /* __cplusplus */
extern	void	vidupdate(chtype, chtype, int (*)()), 
		wsyncup(WINDOW *), wsyncdown(WINDOW *),
		delkeymap(TERMINAL *),
		_ring(char), delscreen(SCREEN *), curserr(void),
		_setqiflush(char), 
		immedok(WINDOW *, int), 
		wtimeout(WINDOW *, int), wbkgdset(WINDOW *, chtype),
		wcursyncup(WINDOW *);

#ifndef _TERM_H
#undef TERMINAL /* Eliminate dreadful kludge */
#endif

extern	int	cbreak(void), nocbreak(void), 
		curs_set(int),
		draino(int),
		reset_prog_mode(void), reset_shell_mode(void),
		def_prog_mode(void), def_shell_mode(void), 
		raw(void),
		_setecho(int), _setnonl(int),
		savetty(void), traceon(void), _meta(int), 
		traceoff(void), noraw(void), flushinp(void), 
		_getsyx(int *, int *),
		nodelay(WINDOW *, int), 
		_overlap(WINDOW *, WINDOW *, int),
		resetty(void), 
		ripoffline(int, int (*)()), 
		scr_init(char *),
		scr_dump(char *),
		scr_restore(char *),
		_scr_all(char *, int),
		setsyx(int, int), 
		slk_clear(void),
		slk_init(int), slk_set(int, char *, int),
		slk_refresh(void), slk_noutrefresh(void),
		slk_restore(void), 
		slk_touch(void),
		tgetent(char *, char *), tgetflag(char *), tgetnum(char *),
		tigetflag(char *), tigetnum(char *),
		notimeout(WINDOW *, int), 
		clearok(WINDOW *, int), 
		leaveok(WINDOW *, int), 
		scrollok(WINDOW *, int), 
		wstandend(WINDOW *), wstandout(WINDOW *); 

extern	int	crmode(void), nocrmode(void), ungetch(int);

#if __cplusplus
}
#endif	/* __cplusplus */
#else
extern	void	vidupdate(), wsyncup(), wsyncdown(),
		delkeymap(), 
		_ring(), delscreen(), curserr(),
		_setqiflush(), 
		immedok(), 
		wtimeout(), wbkgdset(),
		wcursyncup();

extern	int	cbreak(), nocbreak(), 
		reset_prog_mode(), reset_shell_mode(), def_prog_mode(),
		_setecho(), _setnonl(),
		def_shell_mode(), raw(),
		savetty(), traceon(), _meta(), 
		traceoff(), noraw(), flushinp(), _getsyx(),
		nodelay(), resetty(), ripoffline(), setsyx(), slk_refresh(),
		slk_restore(), notimeout(), clearok(), leaveok(),
		scrollok(), wstandend(), wstandout(); 

extern	int	crmode(), nocrmode(), ungetch();
#endif /* _NO_PROTOTYPE */

#define gettmode()		(OK)
#define setterm(name)		setupterm((name),1,(unsigned char*)NULL)
#define getsyx(y,x)		_getsyx(&(y),&(x))

/* 
 * Functions to get at the window structure.
 */

#define getyx(win,y,x)		((y) = getcury(win), (x) = getcurx(win))
#define	getbegyx(win,y,x)	((y) = getbegy(win), (x) = getbegx(win))
#define	getmaxyx(win,y,x)	((y) = getmaxy(win), (x) = getmaxx(win))
#define	getparyx(win,y,x)	((y) = getpary(win), (x) = getparx(win))

#if defined(PERFORMANCE) && !defined(__lint)
#define getcury(win)		((win)->_cury)
#define getcurx(win)		((win)->_curx)
#define	getbegy(win)		((win)->_begy)
#define	getbegx(win)		((win)->_begx)
#define	getmaxy(win)		((win)->_maxy)
#define	getmaxx(win)		((win)->_maxx)
#define	getpary(win)		((win)->_pary)
#define	getparx(win)		((win)->_parx)
#define getbkgd(win)		((win)->_bkgd)
#define getattrs(win)		((win)->_attrs)
#else
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
#ifndef _NO_PROTOTYPE
extern	int getcurx(WINDOW *), getcury(WINDOW *);
extern	int getbegx(WINDOW *), getbegy(WINDOW *);
extern	int getmaxx(WINDOW *), getmaxy(WINDOW *);
extern	int getparx(WINDOW *), getpary(WINDOW *);
extern	chtype getbkgd(WINDOW *), getattrs(WINDOW *);
#if __cplusplus
}
#endif /* __cplusplus */
#endif /* _NO_PROTOTYPE */
#endif	/* defined(PERFORMANCE) && !defined(__lint) */

#ifdef	_VR3_COMPAT_CODE

#define newterm		newterm32
#ifdef __cplusplus
extern	"C" {
#endif /* __cplusplus */
#ifndef _NO_PROTOTYPE
extern	SCREEN	*newterm(char *, FILE *, FILE *),
		*set_term(SCREEN *);

extern	WINDOW	*initscr32(void),
		*subwin(WINDOW *, int, int, int, int),
		*subpad(WINDOW *, int, int, int, int);

extern	int	box32(WINDOW *, chtype, chtype),
		p32echochar(WINDOW *, chtype);

extern	int	w32addch(WINDOW *, chtype),
		w32insch(WINDOW *, chtype),
		w32echochar(WINDOW *, chtype);
#else
extern	SCREEN	*newterm(/*termname,fout,fin*/),
		*set_term(/*screenptr*/);

extern	WINDOW	*initscr32(),
		*subwin(/*orig,nlines,ncols,sbegy,sbegx*/),
		*subpad(/*orig,nlines,ncols,begy,begx*/);
#endif /* _NO_PROTOTYPE */
extern _ochtype	*acs_map;
extern  chtype	*acs32map;
#if __cplusplus
}
#endif /* __cplusplus	*/

/* definitions for Vr3 source compatibility */

#define initscr		initscr32
#define waddch		w32addch
#define wechochar	w32echochar
#define pechochar	p32echochar
#define winsch		w32insch
#define vidputs		vid32puts
#define vidattr		vid32attr
#define wattroff	w32attroff
#define wattron		w32attron
#define wattrset	w32attrset
#define acs_map		acs32map
#define box		box32

#else	/* _VR3_COMPAT_CODE */

#ifdef __cplusplus
extern	"C" chtype	*acs_map;
#else
extern	chtype	*acs_map;
#endif	/* __cplusplus */

#endif	/* _VR3_COMPAT_CODE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
#ifndef _NO_PROTOTYPE
extern	int	wattroff(WINDOW *, chtype), 
		wattron(WINDOW *, chtype), 
		wattrset(WINDOW *, chtype);
#else
extern	int	wattroff(), wattron(), wattrset();
#endif /* _NO_PROTOTYPE */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#if defined(NOMACROS) || defined(__lint)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef _NO_PROTOTYPE
extern	SCREEN	*newterm(char *, FILE *, FILE *),
		*set_term(SCREEN *);

extern	unsigned char	*unctrl(int);

extern	chtype	inch(void),
		mvinch(int, int),
		mvwinch(WINDOW *, int, int);

extern	int	addch(chtype),
		addstr(char *),
		attroff(chtype), attron(chtype), attrset(chtype), 
		beep(void),
		clear(void), clrtobot(void), clrtoeol(void),
		delch(void), deleteln(void),
		echo(void), noecho(void), 
		echochar(chtype),
		erase(void),
		flash(void), 
		garbagedlines(WINDOW *, int, int),
		getch(void),
		getstr(char *),
		insch(chtype),
		insertln(void),
		intrflush(WINDOW *, int), 
		meta(WINDOW *, int), 
		move(int, int),
		mvaddch(int, int, chtype),
		mvaddstr(int, int, char *),
		mvdelch(int, int),
		mvgetch(int, int),
		mvgetstr(int, int, char *),
		mvinsch(int, int, chtype),
		mvwaddstr(WINDOW *, int, int, char *),
		mvwgetch(WINDOW *, int, int),
		mvwinsch(WINDOW *, int, int, chtype),
		nl(void), nonl(void),
		refresh(void),
		setscrreg(int, int),
		standend(void), standout(void);

extern	int	waddch(WINDOW *, chtype);

extern	void	bkgdset(chtype), timeout(int);

extern	WINDOW	*subpad(WINDOW *, int, int, int, int);
extern	WINDOW	*subwin(WINDOW *, int, int, int, int);
#else
extern	SCREEN	*newterm(/*termname,fout,fin*/),
		*set_term(/*screenptr*/);

extern	WINDOW	*subpad(),
		*subwin();

extern	unsigned char	*unctrl();

extern	chtype	inch(),
		mvinch(),
		mvwinch();

extern	int	intrflush(), meta(), noecho(), echo(), nl(), nonl(), beep(),
		flash(), attroff(), attron(), attrset(), standend(),
		standout();

extern	void	bkgdset(), timeout();
#endif /* _NO_PROTOTYPE */

#if __cplusplus
}
#endif /* __cplusplus */

#else	/* NOMACROS || __lint */

/*
 * The defines from here down to the #endif for NOMACROS
 * define macros, which may be more efficient than their
 * function versions. The functions may be accessed by defining
 * NOMACROS in C code. This is useful for debugging purposes.
 */

#include  <unctrl.h>

/* pseudo functions for stdscr */
#define	addch(ch)	waddch(stdscr, ch)
#define	addnstr(s,n)	waddnstr(stdscr,s,n)
#define	addstr(str)	waddstr(stdscr, str)
#define	attroff(at)	wattroff(stdscr,at)
#define	attron(at)	wattron(stdscr,at)
#define	attrset(at)	wattrset(stdscr,at)
#define	bkgd(c)		wbkgd(stdscr,c)

#ifdef _M_COFF
#define	border(ls, rs, ts, bs, tl, tr, bl, br)	wborder(stdscr, ls, rs, ts, bs, tl, tr, bl, br)	
#else
#define border(lc, rc, tc, bc)  wborder(stdscr, lc, rc, tc, bc)
#endif

#define	clear()		wclear(stdscr)
#define	clrtobot()	wclrtobot(stdscr)
#define	clrtoeol()	wclrtoeol(stdscr)
#define	delch()		wdelch(stdscr)
#define	deleteln()	wdeleteln(stdscr)
#define	echochar(ch)	wechochar(stdscr, ch)
#define	erase()		werase(stdscr)
#define	getch()		wgetch(stdscr)
#define	getstr(str)	wgetstr(stdscr, str)
#define	inch()		winch(stdscr)
#define	insch(c)	winsch(stdscr,c)
#define	insdelln(id)	winsdelln(stdscr,id)
#define	insertln()	winsertln(stdscr)
#define	insnstr(s,n)	winsnstr(stdscr,s,n)
#define	insstr(s)	winsstr(stdscr,s)
#define	move(y, x)	wmove(stdscr, y, x)
#define	refresh()	wrefresh(stdscr)
#define	scrl(n)		wscrl(stdscr,n)
#define	setscrreg(t,b)	wsetscrreg(stdscr, t, b)
#define	standend()	wstandend(stdscr)
#define	standout()	wstandout(stdscr)
#define	timeout(tm)	wtimeout(stdscr,tm)
#define	hline(c,num)	whline(stdscr,c,num)
#define	vline(c,num)	wvline(stdscr,c,num)
#define	addchstr(str)	waddchstr(stdscr,str)
#define	addchnstr(str,n)	waddchnstr(stdscr,str,n)
#define	instr(str)	winstr(stdscr,(str))
#define	innstr(str,n)	winnstr(stdscr,(str),(n))
#define	inchstr(str)	winchstr(stdscr,str)
#define	inchnstr(str,n)	winchnstr(stdscr,str,n)
#define	bkgdset(c)	wbkgdset(stdscr,c)

/* functions to define environment flags of a window */
#ifdef	PERFORMANCE
#define	wbkgdset(win,c)		( \
	((win)->_attrs = ( \
			  ((win)->_attrs & ~((win)->_bkgd & A_ATTRIBUTES)) | \
			  (c & A_ATTRIBUTES) \
			 ) \
	), ((win)->_bkgd = (c)) )
#define syncok(win,bf)		((win)->_parent?(win)->_sync=(bf):ERR)
#define	notimeout(win,bf)	((win)->_notimeout = ((bf) ? TRUE : FALSE))
#define	clearok(win,bf)		((win)->_clear = (bf))
#define	leaveok(win,bf)		((win)->_leave = (bf))
#define	scrollok(win,bf)	((win)->_scroll = ((bf) ? TRUE : FALSE))
#define	idcok(win,bf)		((win)->_use_idc = ((bf) ? TRUE : FALSE))
#ifndef _M_UNIX
#define	nodelay(win,bf)		((win)->_delay = (bf) ? 0 : -1)
#endif
#define is_wintouched(win)	((win)->_flags & _WINCHANGED)
#define is_linetouched(win,line)	((((line) >= (win)->_maxy) || \
				     ((line) < 0)) ? ERR : \
				    (((win)->_firstch[(line)] == _INFINITY) ? \
								  FALSE : TRUE))
#endif	/* PERFORMANCE */

/* functions for move and update */
#define	mvaddch(y,x,ch)		mvwaddch(stdscr,y,x,ch)
#define	mvaddnstr(y,x,s,n)	mvwaddnstr(stdscr,y,x,s,n)
#define	mvaddstr(y,x,str)	mvwaddstr(stdscr,y,x,str)
#define	mvdelch(y,x)		mvwdelch(stdscr,y,x)
#define	mvgetch(y,x)		mvwgetch(stdscr,y,x)
#define	mvgetstr(y,x,str)	mvwgetstr(stdscr,y,x,str)
#define	mvinch(y,x)		mvwinch(stdscr,y,x)
#define	mvinsch(y,x,c)		mvwinsch(stdscr,y,x,c)
#define	mvinsnstr(y,x,s,n)	mvwinsnstr(stdscr,y,x,s,n)
#define	mvinsstr(y,x,s)		mvwinsstr(stdscr,y,x,s)
#define	mvaddchstr(y,x,str)	mvwaddchstr(stdscr,y,x,str)
#define	mvaddchnstr(y,x,str,n)	mvwaddchnstr(stdscr,y,x,str,n)
#define	mvinstr(y,x,str)	mvwinstr(stdscr,y,x,(str))
#define	mvinnstr(y,x,str,n)	mvwinnstr(stdscr,y,x,(str),(n))
#define	mvinchstr(y,x,str)	mvwinchstr(stdscr,y,x,str)
#define	mvinchnstr(y,x,str,n)	mvwinchnstr(stdscr,y,x,str,n)
#define	mvhline(y,x,c,num)	mvwhline(stdscr,y,x,c,num)
#define	mvvline(y,x,c,num)	mvwvline(stdscr,y,x,c,num)

#define	mvwaddch(win,y,x,ch)	(wmove(win,y,x)==ERR?ERR:waddch(win,ch))
#define	mvwaddnstr(win,y,x,s,n)	(wmove(win,y,x)==ERR?ERR:waddnstr(win,s,n))
#define	mvwaddstr(win,y,x,str)	(wmove(win,y,x)==ERR?ERR:waddstr(win,str))
#define	mvwdelch(win,y,x)	(wmove(win,y,x)==ERR?ERR:wdelch(win))
#define	mvwgetch(win,y,x)	(wmove(win,y,x)==ERR?ERR:wgetch(win))
#define	mvwgetstr(win,y,x,str)	(wmove(win,y,x)==ERR?ERR:wgetstr(win,str))
#define	mvwinch(win,y,x)	(wmove(win,y,x)==ERR?(chtype) ERR:winch(win))
#define	mvwinsch(win,y,x,c)	(wmove(win,y,x)==ERR?ERR:winsch(win,c))
#define	mvwinsnstr(win,y,x,s,n)	(wmove(win,y,x)==ERR?ERR:winsnstr(win,s,n))
#define	mvwinsstr(win,y,x,s)	(wmove(win,y,x)==ERR?ERR:winsstr(win,s))
#define	mvwhline(win,y,x,c,num)	(wmove(win,y,x)==ERR?ERR:whline(win,c,num))
#define	mvwvline(win,y,x,c,num)	(wmove(win,y,x)==ERR?ERR:wvline(win,c,num))
#define	mvwaddchstr(win,y,x,str)	(wmove(win,y,x)==ERR?ERR:waddchstr(win,str))
#define	mvwaddchnstr(win,y,x,str,n)	(wmove(win,y,x)==ERR?ERR:waddchnstr(win,str,n))
#define	mvwinstr(win,y,x,str)	(wmove(win,y,x)==ERR?ERR:winstr(win,str))
#define	mvwinnstr(win,y,x,str,n)	(wmove(win,y,x)==ERR?ERR:winnstr(win,str,n))
#define	mvwinchstr(win,y,x,str)	(wmove(win,y,x)==ERR?ERR:winchstr(win,str))
#define	mvwinchnstr(win,y,x,str,n)	(wmove(win,y,x)==ERR?ERR:winchnstr(win,str,n))

#ifdef CURSES_MACROS
#define overlay(src,dst)	_overlap((src),(dst),TRUE)
#define overwrite(src,dst)	_overlap((src),(dst),FALSE)
#define wdeleteln(win)		winsdelln((win),-1)
#define winsertln(win)		winsdelln((win),1)
#define wstandend(win)		wattrset((win),A_NORMAL)
#define wstandout(win)		wattron((win),A_STANDOUT)
#define beep()			_ring(TRUE)
#define flash()			_ring(FALSE)
#define scroll(win)		wscrl((win),1)
#define slk_init(f)		slk_start(((f == 0) ? 3 : 2),NULL)
#define	scr_init(file)		_scr_all(file,0)
#define	scr_restore(file)	_scr_all(file,1)
#define subpad(win,nl,nc,by,bx)	derwin((win),(nl),(nc),(by),(bx))
#ifndef _VR3_COMPAT_CODE
#define box(win,v,h)		wborder((win),(v),(v),(h),(h),0,0,0,0)
#define newterm(type,fout,fin)	newscreen((type),0,0,0,(fout),(fin))
#endif
#define touchline(win,y,n)	wtouchln((win),(y),(n),TRUE)
#endif /* CURSES_MACROS */

#define garbagedlines		wredrawln
#define garbagedwin		redrawwin
#ifdef	PERFORMANCE
#define subwin(win,nl,nc,by,bx)	derwin((win),(nl),(nc),(by-win->_begy),(bx-win->_begx))
#define touchwin(win)		wtouchln((win),0,(win)->_maxy,TRUE)
#define redrawwin(win)		wredrawln((win),0,(win)->_maxy)
#define	winchstr(win,str)	winchnstr((win),str,((win)->_maxx - (win)->_curx))
#define	winstr(win,str)		winnstr((win),str,((win)->_maxx - (win)->_curx))
#define untouchwin(win)		wtouchln((win),0,((win)->_maxy),FALSE)
#define	winch(win)		((win)->_y[(win)->_cury][(win)->_curx])
#endif	/* PERFORMANCE */

#ifdef CURSES_MACROS
#define waddstr(win,str)	waddnstr((win),(str),-1)
#define werase(win)		(wmove((win),0,0), wclrtobot(win))
#define wclear(win)		(clearok((win),TRUE), werase(win))
#define intrflush(win,flag)	_setqiflush(flag)
#define meta(win,flag)		_meta(flag)
#endif /* CURSES_MACROS */

#define crmode			cbreak
#define nocrmode		nocbreak
#define saveterm		def_prog_mode
#define fixterm			reset_prog_mode
#define resetterm		reset_shell_mode

#ifdef CURSES_MACROS
#define halfdelay(tens)		ttimeout((tens)*100)
#endif /* CURSES_MACROS */

#define	waddchstr(win,str)	waddchnstr((win),(str),-1)
#define winsstr(win,str)	winsnstr((win),(str),-1)

/* iocontrol functions */
#define qiflush()		_setqiflush(TRUE)
#define noqiflush()		_setqiflush(FALSE)

#ifdef CURSES_MACROS
#define echo()			_setecho(TRUE)
#define noecho()		_setecho(FALSE)
#define nl()			_setnonl(FALSE)
#define nonl()			_setnonl(TRUE)
#endif /* CURSES_MACROS */

/* functions for setting time-out length on inputs */
#ifdef	PERFORMANCE
#define wtimeout(win,tm)	((win)->_delay = (tm))

/* functions for accessing selected TERMINAL fields	*/
#define	can_change_color()	can_change
#define has_colors()		((max_pairs == -1) ? FALSE : TRUE)
#endif	/* PERFORMANCE */

#define set_term		setcurscreen
#define	scr_set(file)		_scr_all(file,2)

#endif	/* NOMACROS || __lint */

/*
 * Standard alternate character set.  The current ACS world is evolving,
 * so we support only a widely available subset: the line drawing characters
 * from the VT100, plus a few from the Teletype 5410v1.  Eventually there
 * may be support of more sophisticated ACS line drawing, such as that
 * in the Teletype 5410, the HP line drawing set, and the like.  There may
 * be support for some non line oriented characters as well.
 *
 * Line drawing ACS names are of the form ACS_trbl, where t is the top, r
 * is the right, b is the bottom, and l is the left.  t, r, b, and l might
 * be B (blank), S (single), D (double), or T (thick).  The subset defined
 * here only uses B and S.
 */

#define ACS_BSSB	(acs_map['l'])
#define ACS_SSBB	(acs_map['m'])
#define ACS_BBSS	(acs_map['k'])
#define ACS_SBBS	(acs_map['j'])
#define ACS_SBSS	(acs_map['u'])
#define ACS_SSSB	(acs_map['t'])
#define ACS_SSBS	(acs_map['v'])
#define ACS_BSSS	(acs_map['w'])
#define ACS_BSBS	(acs_map['q'])
#define ACS_SBSB	(acs_map['x'])
#define ACS_SSSS	(acs_map['n'])

/*
 * Human readable names for the most commonly used characters.
 * "Upper", "right", etc. are chosen to be consistent with the vt100 manual.
 */

#define ACS_ULCORNER	ACS_BSSB
#define ACS_LLCORNER	ACS_SSBB
#define ACS_URCORNER	ACS_BBSS
#define ACS_LRCORNER	ACS_SBBS
#define ACS_RTEE	ACS_SBSS
#define ACS_LTEE	ACS_SSSB
#define ACS_BTEE	ACS_SSBS
#define ACS_TTEE	ACS_BSSS
#define ACS_HLINE	ACS_BSBS
#define ACS_VLINE	ACS_SBSB
#define ACS_PLUS	ACS_SSSS
#define ACS_S1		(acs_map['o'])	/* scan line 1 */
#define ACS_S9		(acs_map['s'])	/* scan line 9 */
#define ACS_DIAMOND	(acs_map['`'])	/* diamond */
#define ACS_CKBOARD	(acs_map['a'])	/* checker board (stipple) */
#define ACS_DEGREE	(acs_map['f'])	/* degree symbol */
#define ACS_PLMINUS	(acs_map['g'])	/* plus/minus */
#define ACS_BULLET	(acs_map['~'])	/* bullet */
	/* Teletype 5410v1 symbols */
#define ACS_LARROW	(acs_map[','])	/* arrow pointing left */
#define ACS_RARROW	(acs_map['+'])	/* arrow pointing right */
#define ACS_DARROW	(acs_map['.'])	/* arrow pointing down */
#define ACS_UARROW	(acs_map['-'])	/* arrow pointing up */
#define ACS_BOARD	(acs_map['h'])	/* board of squares */
#define ACS_LANTERN	(acs_map['i'])	/* lantern symbol */
#define ACS_BLOCK	(acs_map['0'])	/* solid square block */

/* Funny "characters" enabled for various special function keys for input */
/* This list is created from caps and curses.ed. Do not edit it! */
#define KEY_MIN		0401		/* Minimum curses key */
#define KEY_BREAK	0401		/* break key (unreliable) */
#define KEY_DOWN	0402		/* Sent by terminal down arrow key */
#define KEY_UP		0403		/* Sent by terminal up arrow key */
#define KEY_LEFT	0404		/* Sent by terminal left arrow key */
#define KEY_RIGHT	0405		/* Sent by terminal right arrow key */
#define KEY_HOME	0406		/* Sent by home key. */
#define KEY_BACKSPACE	0407		/* Sent by backspace key */
#define KEY_F0		0410		/* function key f0. */
#define KEY_F(n)	(KEY_F0+(n))	/* Space for 64 function keys is reserved. */
#define KEY_DL		0510		/* Sent by delete line key. */
#define KEY_IL		0511		/* Sent by insert line. */
#define KEY_DC		0512		/* Sent by delete character key. */
#define KEY_IC		0513		/* Sent by ins char/enter ins mode key. */
#define KEY_EIC		0514		/* Sent by rmir or smir in insert mode. */
#define KEY_CLEAR	0515		/* Sent by clear screen or erase key. */
#define KEY_EOS		0516		/* Sent by clear-to-end-of-screen key. */
#define KEY_EOL		0517		/* Sent by clear-to-end-of-line key. */
#define KEY_SF		0520		/* Sent by scroll-forward/down key */
#define KEY_SR		0521		/* Sent by scroll-backward/up key */
#define KEY_NPAGE	0522		/* Sent by next-page key */
#define KEY_PPAGE	0523		/* Sent by previous-page key */
#define KEY_STAB	0524		/* Sent by set-tab key */
#define KEY_CTAB	0525		/* Sent by clear-tab key */
#define KEY_CATAB	0526		/* Sent by clear-all-tabs key. */
#define KEY_ENTER	0527		/* Enter/send (unreliable) */
#define KEY_SRESET	0530		/* soft (partial) reset (unreliable) */
#define KEY_RESET	0531		/* reset or hard reset (unreliable) */
#define KEY_PRINT	0532		/* print or copy */
#define KEY_LL		0533		/* Sent by home-down key */
					/* The keypad is arranged like this: */
					/*    a1    up    a3   */
					/*   left   b2  right  */
					/*    c1   down   c3   */
#define KEY_A1		0534		/* Upper left of keypad */
#define KEY_A3		0535		/* Upper right of keypad */
#define KEY_B2		0536		/* Center of keypad */
#define KEY_C1		0537		/* Lower left of keypad */
#define KEY_C3		0540		/* Lower right of keypad */
#define KEY_BTAB	0541		/* Back tab key */
#define KEY_BEG		0542		/* beg(inning) key */
#define KEY_CANCEL	0543		/* cancel key */
#define KEY_CLOSE	0544		/* close key */
#define KEY_COMMAND	0545		/* cmd (command) key */
#define KEY_COPY	0546		/* copy key */
#define KEY_CREATE	0547		/* create key */
#define KEY_END		0550		/* end key */
#define KEY_EXIT	0551		/* exit key */
#define KEY_FIND	0552		/* find key */
#define KEY_HELP	0553		/* help key */
#define KEY_MARK	0554		/* mark key */
#define KEY_MESSAGE	0555		/* message key */
#define KEY_MOVE	0556		/* move key */
#define KEY_NEXT	0557		/* next object key */
#define KEY_OPEN	0560		/* open key */
#define KEY_OPTIONS	0561		/* options key */
#define KEY_PREVIOUS	0562		/* previous object key */
#define KEY_REDO	0563		/* redo key */
#define KEY_REFERENCE	0564		/* ref(erence) key */
#define KEY_REFRESH	0565		/* refresh key */
#define KEY_REPLACE	0566		/* replace key */
#define KEY_RESTART	0567		/* restart key */
#define KEY_RESUME	0570		/* resume key */
#define KEY_SAVE	0571		/* save key */
#define KEY_SBEG	0572		/* shifted beginning key */
#define KEY_SCANCEL	0573		/* shifted cancel key */
#define KEY_SCOMMAND	0574		/* shifted command key */
#define KEY_SCOPY	0575		/* shifted copy key */
#define KEY_SCREATE	0576		/* shifted create key */
#define KEY_SDC		0577		/* shifted delete char key */
#define KEY_SDL		0600		/* shifted delete line key */
#define KEY_SELECT	0601		/* select key */
#define KEY_SEND	0602		/* shifted end key */
#define KEY_SEOL	0603		/* shifted clear line key */
#define KEY_SEXIT	0604		/* shifted exit key */
#define KEY_SFIND	0605		/* shifted find key */
#define KEY_SHELP	0606		/* shifted help key */
#define KEY_SHOME	0607		/* shifted home key */
#define KEY_SIC		0610		/* shifted input key */
#define KEY_SLEFT	0611		/* shifted left arrow key */
#define KEY_SMESSAGE	0612		/* shifted message key */
#define KEY_SMOVE	0613		/* shifted move key */
#define KEY_SNEXT	0614		/* shifted next key */
#define KEY_SOPTIONS	0615		/* shifted options key */
#define KEY_SPREVIOUS	0616		/* shifted prev key */
#define KEY_SPRINT	0617		/* shifted print key */
#define KEY_SREDO	0620		/* shifted redo key */
#define KEY_SREPLACE	0621		/* shifted replace key */
#define KEY_SRIGHT	0622		/* shifted right arrow */
#define KEY_SRSUME	0623		/* shifted resume key */
#define KEY_SSAVE	0624		/* shifted save key */
#define KEY_SSUSPEND	0625		/* shifted suspend key */
#define KEY_SUNDO	0626		/* shifted undo key */
#define KEY_SUSPEND	0627		/* suspend key */
#define KEY_UNDO	0630		/* undo key */
#define KEY_MAX		0777		/* Maximum curses key */

/*
	The definition for 'reg' is not standard, and is provided for
	compatibility reasons. User's are discouraged from using this.
*/
#define	reg	register

/* Various video attributes */
#define A_STANDOUT	000000200000L
#define	_STANDOUT	A_STANDOUT    /* for compatability with old curses */
#define A_UNDERLINE	000000400000L
#define A_REVERSE	000001000000L
#define A_BLINK		000002000000L
#define A_DIM		000004000000L
#define A_BOLD		000010000000L
#define A_ALTCHARSET	000100000000L

/* The next two are subject to change so don't depend on them */
#define A_INVIS		000020000000L
#define A_PROTECT	000040000000L

#define A_NORMAL	000000000000L
#define A_ATTRIBUTES	037777600000L	/* 0xFFFF0000 */
#define A_CHARTEXT	000000177777L	/* 0x0000FFFF */
#define A_COLOR		017600000000L

#define COLOR_PAIR(n)	((n) << 25)
#define PAIR_NUMBER(n)	(((n) & A_COLOR) >> 25)

/*
 * The ansi console driver uses the ISO color mapping scheme.  However,
 * other mappings may be desired.  We define 2 possible mappings here.
 */

#define IBM_BLACK	0
#define IBM_BLUE	1
#define IBM_GREEN	2
#define IBM_CYAN	3
#define IBM_RED	        4
#define IBM_MAGENTA	5
#define IBM_YELLOW	6
#define IBM_WHITE	7

#define ISO_BLACK	0
#define ISO_RED         1
#define ISO_GREEN	2
#define ISO_YELLOW	3
#define ISO_BLUE        4
#define ISO_MAGENTA	5
#define ISO_CYAN	6
#define ISO_WHITE	7

#define COLOR_BLACK	ISO_BLACK
#define COLOR_RED	ISO_RED
#define COLOR_GREEN	ISO_GREEN
#define COLOR_YELLOW	ISO_YELLOW
#define COLOR_BLUE	ISO_BLUE
#define COLOR_MAGENTA	ISO_MAGENTA
#define COLOR_CYAN	ISO_CYAN
#define COLOR_WHITE	ISO_WHITE

#pragma	pack()

#endif /* TINFO_H */
